/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2009-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_pcb.h 801 2011-05-03 13:54:23Z ertl-honda $
 */

/*
 *  ץå¸ץåȥ֥å⥸塼AT91SKYEYEѡ
 */
#ifndef TOPPERS_TARGET_PCB_H
#define TOPPERS_TARGET_PCB_H

#include "at91skyeye.h"

/*
 *  ͥå
 */
#ifndef TTYPE_KLOCK
//#define TTYPE_KLOCK G_KLOCK
#define TTYPE_KLOCK P_KLOCK
#endif /* TTYPE_KLOCK */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_pcb.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȰ¸ץåȥ֥å
 */
typedef struct target_processor_control_block{
	/*
	 * Ƴߤγ׵ػߥե饰ξ
	 */
	uint32_t idf;

	/*
	 * ߤγͥ٥ޥ
	 */
	PRI ipm;

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	uint32_t bitpat_cfgint;

	/*
	 *  ߥޥơ֥ؤΥݥ
	 */
	const uint32_t* p_ipm_mask_tbl;

	/*
	 *  ߥϥɥơ֥ؤΥݥ
	 */
	const FP* p_inh_tbl;

	/*
	 *  ͥ٥ơ֥ؤΥݥ
	 */
	const PRI* p_inh_ipm_tbl;

	/*
	 *  ARM¸ץåȥ֥å
	 */
	APCB arm_pcb;
}TPCB;

/*
 *  åη
 */
typedef uint32_t LOCK;

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_PCB_H */
